.nolist
include \masm32\include\masm32rt.inc

CustomMsgBox	PROTO :DWORD, :DWORD, :DWORD, :DWORD
MsgboxProc		PROTO :DWORD, :DWORD, :DWORD, :DWORD

IDB_EXIT	equ 1001
IDB_ABOUT	equ 1002

.data
msg1	db 'Customized message box with menu', 0
capt	db 'Hello!', 0
btext	db 'Click here', 0
msg2	db 'Message box test', 0
flagCmb	dd 0

.data?
hMboxHook	dd ?
pButtonText	dd ?
pOldProc	dd ?

.code

start:	invoke CustomMsgBox, 0, addr msg1, addr capt, addr btext
;	invoke CustomMsgBox, 0, chr$("Another one"), addr capt, chr$("A button!")
	exit

mboxCBTProc proc uses esi nCode:DWORD, wParam:DWORD, lParam:DWORD
LOCAL rc:RECT
	.if nCode==HCBT_ACTIVATE && flagCmb==0		; HCBT_CREATEWND is too early
		lea esi, rc
		invoke GetWindowRect, wParam, esi
		mov eax, RECT.right[esi]					; same as mov eax, [esi.RECT.right]
		sub eax, RECT.left[esi]
		mov ecx, RECT.bottom[esi]
		sub ecx, RECT.top[esi]
		add ecx, 24
		invoke MoveWindow, wParam, RECT.left[esi], RECT.top[esi], eax, ecx, TRUE

		invoke GetDlgItem, wParam, IDOK
		invoke SetWindowText, eax, pButtonText
		invoke GetModuleHandle, 0
		invoke LoadMenu, eax, 100
		invoke SetMenu, wParam, eax
		mov flagCmb, 1

		invoke SetWindowLong, wParam, GWL_WNDPROC, addr MsgboxProc
		mov pOldProc, eax

		invoke UnhookWindowsHookEx, hMboxHook	; new: unhook immediately

	.endif
	invoke CallNextHookEx, hMboxHook, nCode, wParam, lParam
	ret
mboxCBTProc endp

CustomMsgBox proc hWnd:DWORD, message:DWORD, caption:DWORD, buttontext:DWORD

	push buttontext
	pop pButtonText
	invoke GetCurrentThreadId
	invoke SetWindowsHookEx, WH_CBT, addr mboxCBTProc, NULL, eax
	mov hMboxHook, eax
	invoke MessageBox, 0, message, caption, MB_OKCANCEL

	; invoke UnhookWindowsHookEx, hMboxHook	; moved upstairs

	m2m flagCmb, 0	; needed for multiple uses
	ret

CustomMsgBox ENDP

MsgboxProc	proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	.if uMsg==WM_COMMAND
		.if wParam==IDB_EXIT
			invoke SendMessage, hWnd, WM_CLOSE, 0, 0

		.elseif wParam==IDB_ABOUT
			invoke MessageBox, 0, addr msg2, addr capt, MB_OK

		.endif

;	.elseif uMsg==WM_CLOSE
;		invoke MessageBox, 0, chr$("CLOSE"), chr$("Test"), MB_OK
;		invoke EndDialog, hWnd, 0
;		xor	eax, eax
;		ret
	.endif

	invoke CallWindowProc, pOldProc, hWnd, uMsg, wParam, lParam
	ret

MsgboxProc endp

end start
OPT_Icon	QuestMark
OPT_Tmp2Asm	1
OPT_DelLog	1	; 0=keep the log files
